Index: pjproject/trunk/pjmedia/src/pjmedia-codec/g722.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/g722.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/g722.c	(revision 2760)
@@ -553,6 +553,6 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*16000/1000) 
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*16000/1000))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/g7221.c	(revision 2760)
@@ -775,7 +775,7 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_duration < (PJMEDIA_CODEC_MAX_SILENCE_PERIOD *
-			        (int)codec_data->samples_per_frame / 20)) 
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_duration < (PJMEDIA_CODEC_MAX_SILENCE_PERIOD *
+			         (int)codec_data->samples_per_frame / 20)))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/gsm.c	(revision 2760)
@@ -543,6 +543,6 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000) 
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/ilbc.c	(revision 2760)
@@ -564,6 +564,6 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_period < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000)
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_period < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/ipp_codecs.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/ipp_codecs.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/ipp_codecs.c	(revision 2760)
@@ -1313,7 +1313,7 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_duration < (PJMEDIA_CODEC_MAX_SILENCE_PERIOD *
-				(int)ippc->clock_rate / 1000)) 
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_duration < (PJMEDIA_CODEC_MAX_SILENCE_PERIOD *
+	 			 (int)ippc->clock_rate / 1000)))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/l16.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/l16.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/l16.c	(revision 2760)
@@ -631,7 +631,7 @@
 						NULL);
 	if (is_silence &&
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*
-			       (int)data->clock_rate/1000)
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_duration < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*
+			        (int)data->clock_rate/1000))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;
Index: pjproject/trunk/pjmedia/src/pjmedia/g711.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 2759)
+++ pjproject/trunk/pjmedia/src/pjmedia/g711.c	(revision 2760)
@@ -503,6 +503,6 @@
 						(input->size >> 1), NULL);
 	if (is_silence && 
-	    PJMEDIA_CODEC_MAX_SILENCE_PERIOD != -1 &&
-	    silence_period < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000) 
+	    (PJMEDIA_CODEC_MAX_SILENCE_PERIOD == -1 ||
+	     silence_period < PJMEDIA_CODEC_MAX_SILENCE_PERIOD*8000/1000))
 	{
 	    output->type = PJMEDIA_FRAME_TYPE_NONE;